<!doctype html>
<html
	lang="en"
	xmlns:th="http://www.thymeleaf.org"
	xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{layoutadmin}"
>
	<head>
		<meta charset="UTF-8" />
		<title>Title</title>
	</head>

	<body>
		<div layout:fragment="main">
			<div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
				<div class="container-fluid">
					<div class="header-body">
						<!-- Card stats -->
						<div class="row">
							<div class="col-xl-12 col-lg-12">
								<div class="card card-stats mb-4 mb-xl-0">
									<div class="card-body">
										<div class="row">
											<div class="col">
												<h5 class="card-title text-uppercase text-muted mb-0">Details</h5>
												<span class="h2 font-weight-bold mb-0">Presensi</span>
											</div>
											<div class="col-auto">
												<div
													class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow"
												>
													<i class="fas fa-user-astronaut"></i>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>

			<div class="container-fluid mt--7">
				<!-- Table -->
				<div class="row">
					<div class="col">
						<div class="card shadow">
							<div class="card-header border-0">
								<div class="row align-items-center">
									<div class="col">
										<h3 class="mb-0">Data List</h3>
									</div>
									<div class="col text-right">
										<button type="button" class="btn btn-dark btn-sm" onclick="openModalPresensi()">
											<i class="fas fa-plus-circle"></i> Add
										</button>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-md-4" style="text-align: center; padding: 10px">
									<b style="font-size: 17px" th:text="${jadwalBahasa.namaJadwal}">Intership</b>
								</div>
								<div class="col-md-4" style="text-align: center; padding: 10px">
									<b th:text="${jadwalBahasa.namaKelas}" style="font-size: 17px">MUA-15</b>
								</div>
								<div class="col-md-4" style="text-align: center; padding: 10px">
									<b style="font-size: 17px">Jenis</b>
									<br />
									<p style="font-size: 14px" th:text="${jadwalBahasa.jenis}">
										Sunday, 15:31:00 - 18:00:00
									</p>
								</div>
							</div>
							<br /><br />
							<div class="table-responsive">
								<div class="container-fluid mt--7">
									<!-- Table -->
									<div class="row">
										<div class="col-md-7 col-xs-12">
											<div class="card shadow">
												<div class="card-header border-0">
													<div class="row align-items-center">
														<div class="col">
															<h3 class="mb-0">Form</h3>
														</div>
														<div class="col text-right"></div>
													</div>
												</div>
												<div class="card-body">
													<div class="table-responsive">
														<table
															id="table-presensi"
															data-filter-control="true"
															data-search="true"
															data-show-refresh="true"
															data-flat="true"
															data-pagination="true"
															data-ajax="ajaxRequestPresensi"
															data-side-pagination="server"
														></table>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-5 col-xs-12 mt-6" id="div-detail" style="display: none">
											<div class="card">
												<div class="col-md-12 mt-4">
													<div class="card">
														<div class="card-header pb-0 px-3">
															<h6 class="mb-0">Detail Kuliah</h6>
														</div>
														<div class="card-body pt-4 p-3">
															<ul class="list-group">
																<li
																	class="list-group-item border-0 d-flex p-4 mb-2 bg-gray-100 border-radius-lg"
																>
																	<div class="d-flex flex-column flex-grow-1">
																		<h6 class="mb-3 text-sm" id="text-dosen">
																			Gifar Haidar
																		</h6>
																		<span class="mb-2 text-xs"
																			>Berita Acara:
																			<span
																				class="text-dark font-weight-bold ms-sm-2"
																				id="text-berita"
																				>Lorem ipsum dolor sit amet...</span
																			></span
																		>
																		<span class="mb-2 text-xs"
																			>Waktu Mengajar:
																			<span
																				class="text-dark ms-sm-2 font-weight-bold"
																				id="text-waktu"
																				>Sunday, 15:31:00 - 18:00:00</span
																			></span
																		>
																		<span class="mb-2 text-xs"
																			>Realisasi Mengajar:
																			<span
																				class="text-dark ms-sm-2 font-weight-bold"
																				id="text-realisasi"
																				>Sunday, 15:31:00 - 18:00:00</span
																			></span
																		>
																		<span class="text-xs mb-2"
																			>Pertemuan Ke:
																			<span
																				class="text-dark ms-sm-2 font-weight-bold"
																				id="text-pertemuanke"
																				>1</span
																			></span
																		>
																		<span class="text-xs mb-2"
																			>Link Materi:
																			<span
																				class="text-dark ms-sm-2 font-weight-bold url"
																				id="text-link"
																				>http://localhost:8080/tlc/attendance/detail</span
																			></span
																		>
																		<span class="text-xs"
																			>Pertemuan:
																			<span
																				class="text-dark ms-sm-2 font-weight-bold badge-info"
																				id="text-pertemuan"
																				>Online</span
																			></span
																		>
																		<input type="hidden" id="presensiId" />
																	</div>
																	<div class="ms-auto text-end align-self-start">
																		<button
																			class="btn btn-sm btn-link text-dark px-3 mb-0"
																			type="button"
																			onclick="editModalPresensi()"
																		>
																			<i
																				class="fas fa-pencil-alt text-dark me-2"
																				aria-hidden="true"
																			></i
																			>Edit
																		</button>
																	</div>
																</li>
															</ul>
														</div>
													</div>
												</div>
												<div
													class="col-md-12 mt-4"
													th:if="${not @environment.acceptsProfiles('production')}"
												>
													<div class="card h-100 mb-4">
														<div class="card-header pb-0 px-3">
															<div class="row">
																<div class="col-md-6">
																	<h6 class="mb-0">List Tugas</h6>
																</div>
																<div class="col text-right">
																	<a id="tambahLink" class="btn btn-sm btn-default"
																		><i class="fas fa-plus-circle"></i> Tambah
																		Tugas</a
																	>
																</div>
																<br />
															</div>
														</div>
														<div class="card-body pt-4 p-3">
															<h6
																class="text-uppercase text-body text-xs font-weight-bolder mb-3"
															>
																Newest
															</h6>
															<ul class="list-group">
																<li
																	class="list-group-item border-0 d-flex justify-content-between ps-0 mb-2 border-radius-lg"
																>
																	<div class="d-flex align-items-center">
																		<button
																			class="btn btn-icon-only btn-rounded btn-outline-danger mb-0 me-3 btn-sm d-flex align-items-center justify-content-center"
																		>
																			<i class="fas fa-tasks"></i>
																		</button>
																		<div class="d-flex flex-column">
																			<h6 class="mb-1 text-dark text-sm">
																				Netflix
																			</h6>
																			<span class="text-xs"
																				>27 March 2020, at 12:30 PM</span
																			>
																		</div>
																	</div>
																	<div
																		class="d-flex align-items-center text-danger text-gradient text-sm font-weight-bold"
																	>
																		- $ 2,500
																	</div>
																</li>
															</ul>
														</div>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-5 col-xs-12" id="div-mahasiswa" style="display: none">
											<div class="card shadow">
												<div class="card-header border-0">
													<h3 class="mb-0"></h3>
													<div class="col text-right">
														<button onclick="openModalAdd()" class="btn btn-sm btn-default">
															<i class="fas fa-plus-circle"></i>
															Tambah Mahasiswa
														</button>
													</div>
												</div>
												<div class="card-body">
													<div class="table-responsive">
														<table
															id="tableMahasiswa1"
															data-search="true"
															data-show-refresh="true"
															data-flat="true"
															data-pagination="true"
															data-ajax="ajaxRequestMahasiswa1"
															data-side-pagination="server"
														></table>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-5 col-xs-12 mt-6" id="div-form-jadwal" style="display: none">
											<div class="card-body">
												<form id="submitJadwal">
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<label>Pilih Pertemuan:</label>
																<select
																	id="pertemuan"
																	name="pertemuan"
																	class="form-control"
																>
																	<option value="Offline">Offline</option>
																	<option value="Online">Online</option>
																</select>
																<input
																	type="hidden"
																	th:value="${jadwalBahasa.id}"
																	id="jadwal"
																	name="jadwal"
																/>
																<input type="hidden" id="id" name="id" />
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<label>Jenis:</label>
																<select id="jenis" name="jenis" class="form-control">
																	<option value="LISTENING">Listening</option>
																	<option value="READING">Reading</option>
																	<option value="WRITING">Writing</option>
																	<option value="SPEAKING">Speaking</option>
																</select>
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12 col-sm-12 col-xs-12">
															<div
																class="form-group"
																id="onlineLinkGroup"
																style="display: none"
															>
																<label>Link Online:</label>
																<input
																	type="text"
																	id="linkOnline"
																	name="linkOnline"
																	class="form-control"
																	placeholder="Masukkan link pertemuan online"
																/>
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<label>Dosen :</label>
																<select name="dosen" class="form-control" id="dosen">
																	<option value=""></option>
																	<option
																		th:each="data : ${jadwalBahasa.getDosens()}"
																		th:text="${data.karyawan.namaKaryawan}"
																		th:value="${data.id}"
																	></option>
																</select>
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<label>Sesi :</label>
																<select name="detail" id="detail" class="form-control">
																	<option
																		th:each="data : ${sesi}"
																		th:text="${data.jamMulai + ' - ' + data.jamSelesai}"
																		th:value="${data.id}"
																	></option>
																</select>
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<label>Berita Acara :</label>
																<textarea
																	name="beritaAcara"
																	class="form-control"
																	id="beritaAcara"
																></textarea>
															</div>
														</div>
													</div>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group" id="div-button-tambah">
																<button
																	type="button"
																	onclick="tambahJadwal()"
																	class="btn btn-primary"
																>
																	Simpan
																</button>
															</div>
														</div>
														<div
															class="col-md-12"
															style="display: none"
															id="div-button-update"
														>
															<div class="form-group">
																<button
																	type="button"
																	onclick="tambahJadwal()"
																	class="btn btn-primary"
																>
																	Update
																</button>
															</div>
														</div>
													</div>
												</form>
											</div>
										</div>

										<div
											class="col-md-5 col-xs-12 mt-6"
											id="div-form-presensi"
											style="display: none"
										>
											<div class="card-body">
												<form id="submitPresensi">
													<table
														id="tableMahasiswa"
														data-search="true"
														data-show-refresh="true"
														data-flat="true"
														data-pagination="true"
														data-ajax="ajaxRequestMahasiswa"
														data-side-pagination="server"
													></table>
													<div class="row">
														<div class="col-md-12">
															<div class="form-group">
																<button
																	type="button"
																	onclick="tambahJadwal()"
																	class="btn btn-primary"
																>
																	Simpan
																</button>
															</div>
														</div>
													</div>
												</form>
											</div>
										</div>
									</div>
									<!-- Dark table -->
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</body>
</html>
<script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
<link href="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.css" rel="stylesheet" />
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/filter-control/bootstrap-table-filter-control.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/auto-refresh/bootstrap-table-auto-refresh.min.js"></script>
<script>
	function openDetail(args) {
		$tableDetail.bootstrapTable("refresh");
		$("#div-form-jadwal").slideUp("slow");
		document.getElementById("div-form-jadwal").style.display = "none";
		$("#div-form-presensi").slideUp("slow");
		document.getElementById("div-form-presensi").style.display = "none";
		$("#div-detail").slideDown("slow");
		document.getElementById("div-detail").style.display = "block";
		$("#presensiId").val(args.id);
		document.getElementById("text-dosen").innerHTML = args.dosen;
		document.getElementById("text-berita").innerHTML = args.berita;
		document.getElementById("text-waktu").innerHTML = args.mulai;
		document.getElementById("text-realisasi").innerHTML = formatDateTime(args.waktu);
		document.getElementById("text-pertemuanke").innerHTML = args.pertemuanke;
		if (args.linkPertemuan != null) {
			document.getElementById("text-link").innerHTML = args.link;
		} else {
			document.getElementById("text-link").innerHTML = "-";
		}
		document.getElementById("text-pertemuan").innerHTML = args.pertemuan;
	}

	function toggleOnlineLink() {
		const pertemuanValue = document.getElementById("pertemuan").value;
		const onlineLinkGroup = document.getElementById("onlineLinkGroup");

		onlineLinkGroup.style.display = pertemuanValue === "online" ? "block" : "none";
	}

	document.getElementById("pertemuan").addEventListener("change", toggleOnlineLink);
	document.addEventListener("DOMContentLoaded", toggleOnlineLink);

	function openMahasiswa(args) {
		$("#idjadwal").val(args.id);
		$("#div-detail").slideUp("slow");
		document.getElementById("div-detail").style.display = "none";
		$tableMahasiswa.bootstrapTable("refresh");
		$("#div-mahasiswa").slideDown("slow");
	}

	var $tableDetail = $("#tableDetail");
	var $tablePresensi = $("#table-presensi");
	var $tableMahasiswa = $("#tableMahasiswa");

	function openModalAdd(row) {
		$("#tambahModal").modal({
			show: true,
			backdrop: "static",
		});
	}

	$(function () {
		$tablePresensi.bootstrapTable({
			columns: [
				{
					field: "dosen",
					title: "Dosen",
					align: "center",
					valign: "middle",
					sortable: true,
				},
				{
					field: "waktu",
					title: "Jam Masuk",
					align: "center",
					valign: "middle",
					sortable: true,
					formatter: formatDate,
				},
				{
					field: "operate",
					title: "Item Operate",
					align: "center",
					clickToSelect: false,
					events: window.operateEvents,
					formatter: operateFormatter,
				},
			],
		});
	});

	$(function () {
		$tableMahasiswa.bootstrapTable({
			columns: [
				{
					field: "nim",
					title: "Nim",
					align: "center",
					valign: "middle",
					sortable: true,
				},
				{
					field: "nama",
					title: "Mahasiswa",
					align: "center",
					valign: "middle",
					sortable: true,
				},
				{
					field: "operate",
					title: "Item Operate",
					align: "center",
					clickToSelect: false,
					events: window.mahasiswaEvent,
					formatter: mahasiswaFormatter,
				},
			],
		});
	});

	$(function () {
		$tableDetail.bootstrapTable({
			columns: [
				{
					field: "namaJadwal",
					title: "Matakuliah",
					align: "center",
					valign: "middle",
				},
				{
					field: "namaKelas",
					title: "Kelas",
					align: "center",
					valign: "middle",
				},
				{
					field: "jenis",
					title: "Jenis",
					align: "center",
					valign: "middle",
				},
				{
					field: "operate",
					title: "Item Operate",
					align: "center",
					clickToSelect: false,
					events: window.jadwalEvent,
					formatter: jadwalFormatter(),
				},
			],
		});
	});

	function ajaxRequestJadwal(params) {
		if ($("#idTahun").val() != "") {
			var url = "/tlc/jadwal-list/" + $("#idTahun").val();
			$.get(url + "?" + $.param(params.data)).then(function (res) {
				params.success(res);
			});
		}
	}

	function ajaxRequestMahasiswa(params) {
		if ($("#idjadwal").val() != "") {
			var url =
				"/tlc/presensi-mahasiswa/" +
				document.getElementById("jadwal").value +
				"?presensiId=" +
				document.getElementById("presensiId").value;
			$.get(url + "&" + $.param(params.data)).then(function (res) {
				params.success(res);
			});
		}
	}

	function ajaxRequestPresensi(params) {
		var url = "/tlc/presensi-dosen/" + $("#jadwal").val();
		$.get(url + "?" + $.param(params.data)).then(function (res) {
			params.success(res);
		});
	}

	function operateFormatter(value, row, index) {
		return [
			'<button type="button" class="btn btn-sm btn-info view">',
			'<i class="fas fa-eye view"></i> View',
			"</button>  &nbsp;",
			'<button type="button" class="btn btn-sm btn-primary presensi">',
			'<i class="fas fa-edit edit"></i> Presensi',
			"</button>  &nbsp;",
		].join("");
	}

	function formatDate(value) {
		if (!value) return "-";
		const date = new Date(value);
		const options = {
			weekday: "long",
			year: "numeric",
			month: "long",
			day: "numeric",
			// hour: '2-digit',
			// minute: '2-digit',
			// hour12: false
		};
		return new Intl.DateTimeFormat("id-ID", options).format(date).replace(", ", ", ");
	}

	function jadwalFormatter(value, row, index) {
		return [
			'<button type="button" class="btn btn-sm btn-info view">',
			'<i class="fas fa-eye view"></i> View',
			"</button>  &nbsp;",
			'<button type="button" class="btn btn-sm btn-primary edit">',
			'<i class="fas fa-edit edit"></i> Edit',
			"</button>  &nbsp;",
			'<button type="button" class="btn btn-sm btn-danger delete">',
			'<i class="fa fa-trash"></i> Hapus',
			"</button>",
		].join("");
	}

	function mahasiswaFormatter(value, row, index) {
		// Jika presensi null, gunakan "-"
		const presensi = row && row.presensi ? row.presensi : "-";

		return [
			'<select class="form-control" id="kehadiran-' +
				row.nim +
				'" name="kehadiran" onchange="updateKehadiran(this, \'' +
				row.nim +
				"', '" +
				row.id +
				"')\">",
			'<option value="-" ' + (presensi === "-" ? "selected" : "") + ">-</option>",
			'<option value="HADIR" ' + (presensi === "HADIR" ? "selected" : "") + ">Hadir</option>",
			'<option value="MANGKIR" ' + (presensi === "MANGKIR" ? "selected" : "") + ">Mangkir</option>",
			'<option value="IZIN" ' + (presensi === "IZIN" ? "selected" : "") + ">IZIN</option>",
			'<option value="SAKIT" ' + (presensi === "SAKIT" ? "selected" : "") + ">SAKIT</option>",
			"</select>",
		].join("");
	}

	window.operateEvents = {
		"click .view": function (e, value, row, index) {
			openDetail(row);
		},
		"click .presensi": function (e, value, row, index) {
			openModalMahasiswa(row);
		},
		"click .delete": function (e, value, row, index) {
			deleteJabatan(row.id);
		},
	};

	window.jadwalEvent = {
		"click .view": function (e, value, row, index) {
			openMahasiswa(row);
		},
		"click .edit": function (e, value, row, index) {
			window.location.href = "/tlc/periode/edit?id=" + row.id;
		},
		"click .delete": function (e, value, row, index) {
			deleteJabatan(row.id);
		},
	};

	window.mahasiswaEvent = {
		"click .view": function (e, value, row, index) {
			openMahasiswa(row);
		},
		"click .edit": function (e, value, row, index) {
			window.location.href = "/tlc/periode/edit?id=" + row.id;
		},
		"click .delete": function (e, value, row, index) {
			deleteJabatan(row.id);
		},
	};

	function openModalPresensi() {
		document.getElementById("div-button-update").style.display = "none";
		document.getElementById("div-button-tambah").style.display = "block";
		$("#submitJadwal")[0].reset();
		$("#div-detail").slideUp("slow");
		document.getElementById("div-detail").style.display = "none";
		$("#div-form-jadwal").slideDown("slow");
		document.getElementById("div-form-jadwal").style.display = "block";
	}

	function openModalMahasiswa(args) {
		$("#presensiId").val(args.id);
		$tableMahasiswa.bootstrapTable("refresh");
		$("#div-detail").slideUp("slow");
		document.getElementById("div-detail").style.display = "none";
		$("#div-form-presensi").slideDown("slow");
		document.getElementById("div-form-presensi").style.display = "block";
	}

	function editModalPresensi() {
		document.getElementById("div-button-tambah").style.display = "none";
		document.getElementById("div-button-update").style.display = "block";
		$("#div-detail").slideUp("slow");
		document.getElementById("div-detail").style.display = "none";
		$("#div-form-jadwal").slideDown("slow");
		document.getElementById("div-form-jadwal").style.display = "block";
		const url = "/tlc/detail-presensi-dosen/" + $("#presensiId").val();
		$.getJSON(url, function (data) {
			console.log(data.beritaAcara);
			$("#id").val(data.id);
			$("#pertemuan").val(data.pertemuan);
			$("#dosen").val(data.dosen.id);
			$("#beritaAcara").val(data.beritaAcara);
			$("#jenis").val(data.jenis);
			$("#detail").val(data.detailJadwalBahasa.id);
		});
	}

	function tambahJadwal() {
		var request = {};
		var token = $("input[name='_csrf']").val();

		request["id"] = $("#id").val();
		request["jadwal"] = $("#jadwal").val();
		request["sesi"] = $("#detail").val();
		request["dosen"] = $("#dosen").val();
		request["pertemuan"] = $("#pertemuan").val();
		request["berita"] = $("#beritaAcara").val();
		request["jenis"] = $("#jenis").val();

		$.ajax({
			type: "POST",
			contentType: "application/json",
			headers: { "X-CSRF-TOKEN": token },
			url: "/tlc/presensi-dosen/" + $("#jadwal").val(),
			data: JSON.stringify(request), // Ensure data is sent in JSON format
			dataType: "json",
			cache: false,
			timeout: 600000,
			success: function (result) {
				$("#submitJadwal")[0].reset();
				Swal.fire({
					position: "top-end",
					icon: "success",
					title: "Data Tersimpan",
					showConfirmButton: false,
					timer: 2000,
				});
				$("#div-form-jadwal").slideDown("slow");
				document.getElementById("div-form-jadwal").style.display = "none";
				$tablePresensi.bootstrapTable("refresh");
			},
			error: function (result) {
				// Handle the error response here if needed
			},
		});
	}

	function updateKehadiran(selectElement, mahasiswaId) {
		const kehadiran = selectElement.value;
		const presensiId = document.getElementById("presensiId").value;
		const token = $("input[name='_csrf']").val(); // Ambil CSRF token jika diperlukan

		const requestData = {
			mahasiswaId: mahasiswaId,
			kehadiran: kehadiran,
			presensiId: presensiId,
		};

		$.ajax({
			url: "/tlc/attendance/update-kehadiran", // Sesuaikan URL endpoint
			type: "POST",
			contentType: "application/json",
			headers: { "X-CSRF-TOKEN": token }, // Jika ada CSRF
			data: JSON.stringify(requestData),
			success: function (response) {
				Swal.fire({
					position: "top-end",
					icon: "success",
					title: "Kehadiran berhasil diperbarui",
					showConfirmButton: false,
					timer: 2000,
				});
			},
			error: function (error) {
				Swal.fire({
					icon: "error",
					title: "Oops...",
					text: "Terjadi kesalahan saat memperbarui kehadiran",
				});
			},
		});
	}

	function formatDateTime(dateTimeString) {
		const options = {
			weekday: "long", // Full name of the weekday (e.g., Rabu)
			year: "numeric", // Full numeric year (e.g., 2024)
			month: "long", // Full name of the month (e.g., Oktober)
			day: "numeric", // Day of the month (e.g., 30)
			hour: "2-digit", // 2-digit hour (e.g., 16)
			minute: "2-digit", // 2-digit minute (e.g., 00)
			hour12: false, // 24-hour format
		};

		const date = new Date(dateTimeString);
		const formattedDate = new Intl.DateTimeFormat("id-ID", options).format(date);

		return formattedDate;
	}
</script>
